<template>
  <v-container :fluid="true" class="d-flex justify-center align-center fill-height">
    <div class="bg-image"></div>
    <v-row>
      <v-col cols="12">
        <div class="d-flex justify-center align-center flex-column text-center">
          <v-card class="pa-6" min-width="400" max-width="350">
            <v-img
                alt="Vetvite logo"
                class="shrink mx-auto"
                contain
                min-width="100"
                src="@/assets/images/logo/logo-blue.png"
                width="100"
            />
            <v-card-title class="text-center d-block">Vous avez perdu votre mot de passe ?</v-card-title>
            <v-alert id="errorAlert" class="d-none text-left" type="error"></v-alert>
            <v-alert id="successAlert" class="d-none text-left" type="success">
              Un email vient d'être envoyé à <b>{{ email }}</b> !
            </v-alert>
            <v-form ref="form" @submit.prevent="forgot" v-model="isValid">
              <v-text-field
                  type="email"
                  v-model="email"
                  :rules="[$utils.rules.required, $utils.rules.email]"
                  hide-details
                  label="Saisissez votre email"
                  class="mb-5" />
              <p>Nous vous enverrons <b>par email</b> un lien pour<br>réinitialiser votre mot de passe !</p>
              <v-btn depressed type="submit" color="primary" class="mt-2" full-width :loading="loading"
                     :disabled="loading || !isValid">Réinitialiser mon mot de passe
              </v-btn>
            </v-form>
          </v-card>
          <router-link :to="{name:'Login'}" class="mt-2 white--text hover-underline hover-opacity">Se connecter ?
          </router-link>
        </div>
      </v-col>
    </v-row>
  </v-container>

</template>

<script>

import Vue from "vue";

export default {
  name: 'ForgotPassword',
  data() {
    return {
      isValid: false,
      loading: false,
      email: "",
    }
  },
  methods: {
    forgot: function () {

      this.loading = true;

      let errorAlert = document.getElementById('errorAlert');
      let successAlert = document.getElementById('successAlert');

      errorAlert.classList.remove('d-flex');
      successAlert.classList.remove('d-flex');

      let route = this.$router.resolve({name: 'ResetPassword'})

      Vue.prototype.$apiRest.post('/user/forgot', {email: this.email, url: window.location.origin + route.href})
          .then(() => {
            successAlert.classList.add('d-flex');
          })
          .catch(err => {
            errorAlert.innerHTML = err.response ? (err.response.data ? err.response.data : err.response) : err ;
            errorAlert.classList.add('d-flex');
          })
          .finally(() => this.loading = false);
    }
  }
}
</script>
